/*
* Delivered as a contribution to Web Services Interoperability
* Organization (WS-I) under Section (2) of the WS-I IPR Agreement.
*
* Copyright (c) 2003 Sun Microsystems, Inc.
* All rights reserved. 
*/

package com.sun.wsi.scm.manufacturer;

import java.util.Vector;
import java.math.BigInteger;

import com.sun.wsi.scm.manufacturer.po.Item;
import com.sun.wsi.scm.manufacturer.po.Reason;
import com.sun.wsi.scm.manufacturer.po.SubmitPOFaultType_Exception;

import com.sun.wsi.scm.util.WSIConstants;

public class POValidator implements WSIConstants {
	public static void validateOrder(Item[] itemArray, int[] productId, int[][] manufacturerData) throws SubmitPOFaultType_Exception {

		Vector validProducts = new Vector();
		for (int i=0; i<productId.length; i++)
			validProducts.add(new BigInteger(String.valueOf(productId[i])));

		for (int i=0; i<itemArray.length; i++) {
			BigInteger productNumber = itemArray[i].getID();
			int qty = itemArray[i].getQty();

			// Reject the order for an invalid quantity (<= 0)
			if (qty <= 0) {
				throw new SubmitPOFaultType_Exception(Reason.fromString("InvalidQty"));
			}

			// Reject the order for a product that does not exist
			if (!validProducts.contains(productNumber)) {
				throw new SubmitPOFaultType_Exception(Reason.fromString("InvalidProduct"));
			}

			/*
			* Not sure if this check should be done
			for (int j=0; j<productId.length; j++) {
				System.out.println("productId: " + productId[j]);
				System.out.println("productNumber: " + productNumber);
				System.out.println("qty: " + qty);
				System.out.println("manufacturerData: " + manufacturerData[j][MAX]);
				// Reject the order for an invalid quantity (> MAX)
				if ((productNumber.intValue() == productId[j]) &&
					(qty > manufacturerData[j][MAX])) {
					System.out.println("qty > manufacturerData[j][MAX]");
					throw new SubmitPOFaultType_Exception(Reason.fromString("InvalidQty"));
				}
			}
			*/

			// When can we throw "MalformedOrder" fault
		}
	}
}

