/*
* Delivered as a contribution to Web Services Interoperability
* Organization (WS-I) under Section (2) of the WS-I IPR Agreement.
*
* Copyright (c) 2003 Sun Microsystems, Inc.
* All rights reserved. 
*/

package com.sun.wsi.scm.util;

import java.util.Hashtable;

import com.sun.wsi.scm.configuration.ConfigurationType;
import com.sun.wsi.scm.configuration.ConfigurationEndpointType;
import com.sun.wsi.scm.configuration.ConfigurationFaultType;
import com.sun.wsi.scm.configuration.ConfigurationEndpointRole;

public class ConfigurationValidator {
	/**
	* Validate the configurationHeader
	*/
	public static Hashtable validateHeader(ConfigurationType configurationHeader) throws ConfigurationFaultType {
		if (configurationHeader.getUserId().equals(""))
			throw new ConfigurationFaultType(false, "Invalid UserId", new ConfigurationEndpointRole[0]);

		ConfigurationEndpointType[] serviceUrl = configurationHeader.getServiceUrl();
		if (serviceUrl == null)
			throw new ConfigurationFaultType(false, "Invalid serviceUrl", new ConfigurationEndpointRole[0]);

		if ((serviceUrl.length != 8)) {
			throw new ConfigurationFaultType(false, serviceUrl.length + " entries found in configuration header, expected \"8\"", new ConfigurationEndpointRole[0]);
		}

		Hashtable roles = new Hashtable();
		for (int i=0; i<serviceUrl.length; i++) {
			if (serviceUrl[i].getRole() == null)
				throw new ConfigurationFaultType(false, "Null role not permitted", new ConfigurationEndpointRole[0]);

			if (serviceUrl[i].get_value() == null) {
				ConfigurationEndpointRole[] role = { serviceUrl[i].getRole() };
				throw new ConfigurationFaultType(false, "Null URIs not permitted", role);
			}

			roles.put(serviceUrl[i].getRole(), serviceUrl[i].get_value().toString());

			// TBD: check for the validity of configurationHeader and
			// throw ConfigurationFaultType for the first invalid
			// serviceUrl
		}

		return roles;
	}
}

