/*
* Delivered as a contribution to Web Services Interoperability
* Organization (WS-I) under Section (2) of the WS-I IPR Agreement.
*
* Copyright (c) 2003 Sun Microsystems, Inc.
* All rights reserved. 
*/

package com.sun.wsi.scm.util;

public interface WSIConstants {
	String CONFIGURATION_NAMESPACE = "http://www.ws-i.org/SampleApplications/SupplyChainManagement/2002-08/Configuration.xsd";
	String RETAIL_ORDER_NAMESPACE = "http://www.ws-i.org/SampleApplications/SupplyChainManagement/2002-08/RetailOrder.xsd";
	String SOAP_ENVELOPE_NAMESPACE = "http://schemas.xmlsoap.org/soap/envelope/";

	String ORDER_NUMBER = "1";
	float PO_ITEM_PRICE = (float)1.00;
	float PO_TOTAL_PRICE = (float)2.00;

	String WAREHOUSE_CALLBACK_LOCATION = "/scm/warehouse/callback";

	int[] PRODUCT_ID = {
		605001,
		605002,
		605003,
		605004,
		605005,
		605006,
		605007,
		605008,
		605009
	};

	int STOCK = 0;
	int MIN = 1;
	int MAX = 2;

	// Stock, Minimum, Maximum
	int[][] WAREHOUSEA_DATA = {
		{ 10, 5, 25 },
		{ 7, 4, 20 },
		{ 15, 10, 50 },
		{ 55, 10, 70 },
		{ 10, 5, 10 },
		{ 20, 5, 20 },
		{ 70, 30, 100 },
		{ 25, 10, 50 },
		{ 20, 20, 50 }
	};

	// Stock, Minimum, Maximum
	int[][] WAREHOUSEB_DATA = {
		{ 30, 5, 55 },
		{ 10, 4, 20 },
		{ 15, 10, 50 },
		{ 70, 10, 70 },
		{ 10, 5, 10 },
		{ 20, 5, 20 },
		{ 30, 30, 100 },
		{ 35, 10, 50 },
		{ 30, 20, 50 }
	};

	// Stock, Minimum, Maximum
	int[][] WAREHOUSEC_DATA = {
		{ 45, 5, 55 },
		{ 20, 4, 20 },
		{ 15, 10, 50 },
		{ 11, 10, 70 },
		{ 10, 5, 10 },
		{ 20, 5, 20 },
		{ 85, 30, 100 },
		{ 45, 10, 50 },
		{ 40, 20, 50 }
	};

	int[] MANUFACTURERA_PRODUCTS = { 605001, 605004, 605007 };
	int[] MANUFACTURERB_PRODUCTS = { 605002, 605005, 605008 };
	int[] MANUFACTURERC_PRODUCTS = { 605003, 605006, 605009 };

	// Stock, Minimum, Maximum
	int[][] MANUFACTURERA_DATA = {
		{ 10, 5, 25 },
		{ 5570, 105, 70100 },
		{ 70, 30, 100 }
	};

	// Stock, Minimum, Maximum
	int[][] MANUFACTURERB_DATA = {
		{ 5, 5, 10 },
		{ 10, 5, 10 },
		{ 35, 10, 50 }
	};

	// Stock, Minimum, Maximum
	int[][] MANUFACTURERC_DATA = {
		{ 15, 10, 50 },
		{ 20, 5, 20 },
		{ 40, 20, 50 }
	};

	String RETAILER_GET_CATALOG = "Retailer.getCatalog";
	String RETAILER_SUBMIT_ORDER = "Retailer.submitOrder";
	String WAREHOUSEA_SHIP_GOODS = "WarehouseA.ShipGoods";
	String WAREHOUSEB_SHIP_GOODS = "WarehouseB.ShipGoods";
	String WAREHOUSEC_SHIP_GOODS = "WarehouseC.ShipGoods";
	String SUBMIT_SN = "submitSN";
	String WAREHOUSEA_ERROR_PO = "WarehouseA.errorPO";
	String WAREHOUSEB_ERROR_PO = "WarehouseB.errorPO";
	String WAREHOUSEC_ERROR_PO = "WarehouseC.errorPO";
	String MANUFACTURERA_SUBMIT_PO = "ManufacturerA.submitPO";
	String MANUFACTURERB_SUBMIT_PO = "ManufacturerB.submitPO";
	String MANUFACTURERC_SUBMIT_PO = "ManufacturerC.submitPO";

	long CALLBACK_DELAY = 5000;		// 5000 milli seconds

	String LOGGER = "com.sun.wsi.scm";

	String WAREHOUSEA = "WarehouseA";
	String WAREHOUSEB = "WarehouseB";
	String WAREHOUSEC = "WarehouseC";

	String MANUFACTURERA = "ManufacturerA";
	String MANUFACTURERB = "ManufacturerB";
	String MANUFACTURERC = "ManufacturerC";

	String[] SERVICE_NAMES = { "Logging Facility",
				"Retailer",
				"WarehouseA",
				"WarehouseB",
				"WarehouseC",
				"ManufacturerA",
				"ManufacturerB",
				"ManufacturerC"
			};

	int LOGGING_SERVICE = 0;
	int RETAILER_SERVICE = 1;
	int WAREHOUSEA_SERVICE = 2;
	int WAREHOUSEB_SERVICE = 3;
	int WAREHOUSEC_SERVICE = 4;
	int MANUFACTURERA_SERVICE = 5;
	int MANUFACTURERB_SERVICE = 6;
	int MANUFACTURERC_SERVICE = 7;

}

